import 'dart:ui';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'constants.dart' as constants;
import 'package:intl/intl.dart';
class DateUtility{
  List<String> daysInEnglish=["Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday"];
  List<String> daysInItalian=["Lunedì","Martedì","Mercoledì","Giovedì","Venerdì","Sabato","Domenica"];
  List<String> monthsInEnglish=["January","February","March","April","May","June","July","August","September","October","November","December"];
  List<String> monthsInItalian=["Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre"];
  List<String> orari=["00:00", "00:30", "01:00", "01:30", "02:00","02:30", "03:00", "03:30", "04:00", "04:30","05:00", "05:30", "06:00", "06:30", "07:00","07:30", "08:00", "08:30", "09:00", "09:30","10:00", "10:30", "11:00", "11:30", "12:00","12:30", "13:00", "13:30", "14:00", "14:30","15:00", "15:30", "16:00", "16:30", "17:00","17:30", "18:00", "18:30", "19:00", "19:30","20:00", "20:30", "21:00", "21:30", "22:00","22:30", "23:00", "23:30"];

  String getDayName(DateTime d){
    String day=DateFormat('EEEE').format(d).toString();
    for(int i=0;i<daysInEnglish.length;i++){
      if(day.compareTo(daysInEnglish[i])==0){
        return daysInItalian[i].substring(0,1);
      }
    }
  }

  List<Text> getOrariWidget(){
    List<Text> orariWidget=new List<Text>();
    for(int i=0;i<orari.length;i++){
      orariWidget.add(new Text(
        orari[i],
        style: TextStyle(
          fontSize: 20,
        ),
      ));
    }
    return getOrariWidget();
  }

  String getMonthName(DateTime d){
    String month=DateFormat('MMMM').format(d).toString();
    for(int i=0;i<daysInEnglish.length;i++){
      if(month.compareTo(monthsInEnglish[i])==0){
        return monthsInItalian[i];
      }
    }
  }


  List<DateTime> getDaysInBeteween(DateTime startDate, DateTime endDate) {
    List<DateTime> days = [];
    for (int i = 0; i <= endDate.difference(startDate).inDays; i++) {
      days.add(startDate.add(Duration(days: i)));
    }
    return days;
  }

  DateTime getLastDayInMonth(DateTime date){
    return DateTime.utc(date.year, date.month + 1, 0);
    //return new DateTime(date.year,date.month,getDaysInMonth(date));
  }

  int getDaysInMonth(DateTime date){
    var firstDayThisMonth = new DateTime(date.year, date.month, date.day);
    var firstDayNextMonth = new DateTime(firstDayThisMonth.year, firstDayThisMonth.month + 1, firstDayThisMonth.day);
    return firstDayNextMonth.difference(firstDayThisMonth).inDays;
  }

  DateTime getEndDate(DateTime startDate){
    return new DateTime(startDate.year+1, startDate.month, startDate.day);
  }

  List<String> getMonths(){
    return monthsInItalian;
  }

  bool isSameDate(DateTime dateTime1, DateTime dateTime2) {
    return dateTime1.year == dateTime2.year && dateTime1.month == dateTime2.month
        && dateTime1.day == dateTime2.day;
  }

  int getMonthNumber(String month){
    int pos=0;
    for(int i=0;i<monthsInItalian.length;i++){
      if(month.compareTo(monthsInItalian[i])==0){
        pos=i+1;
        return pos;
      }
    }
    return 0;
  }
}