import 'package:hive/hive.dart';

Box meetingBox;

class HiveDBHelper{

  static initMyHiveDB() async{
    if(meetingBox==null){
      meetingBox=await Hive.openBox("MeetingsToJoin");
    }
  }

  static Box getBox(){
    return meetingBox;
  }

  static void registerMeeting(String id){
    if(!meetingBox.containsKey(id)){
      meetingBox.put(id, "y");  //y means that you'll join the meeting
    }
    String val=meetingBox.get(id);
    if(val.compareTo("n")==0){
      meetingBox.delete(id);
      meetingBox.put(id, "y");
    }

  }

  static void deleteMeeting(String id){
    meetingBox.delete(id);
    meetingBox.put(id, "n");  //n means that you won't join the meeting
  }

  static bool hasJoined(String id){

    if(!meetingBox.containsKey(id)){
      return false;
    }
    String val=meetingBox.get(id);
    if(val.compareTo("y")==0){
      return true;
    }
    return false;
  }

}

