import 'package:auto_size_text/auto_size_text.dart';
import 'package:we_clean_project/dateUtility.dart';
import 'package:flutter/material.dart';
import 'dart:ui';
import 'package:flutter/cupertino.dart';
import 'constants.dart' as constants;
import 'dart:convert';
import 'package:flutter/services.dart';
import 'package:webview_flutter/webview_flutter.dart';
import 'dart:io';

class NewsOpen extends StatefulWidget {
  NewsOpen({Key key, this.text, this.title, this.image1, this.image2, this.image3, this.image4, this.image5,this.dateTime})
      : super(key: key);
  final text;
  final title;
  final dateTime;
  final image1;
  final image2;
  final image3;
  final image4;
  final image5;
  @override
  _NewsOpen createState() => _NewsOpen();
}

class _NewsOpen extends State<NewsOpen> {
  String text;
  String title;
  String dateTime;
  List<String> imagesString=new List<String>();
  List<Image> imgs=new List<Image>();
  DateUtility dateUtility=new DateUtility();


  @override
  void initState() {
    //if (Platform.isAndroid) WebView.platform = SurfaceAndroidWebView();

    text=widget.text;
    title=widget.title;
    dateTime=widget.dateTime;
    imagesString.add(widget.image1);
    imagesString.add(widget.image2);
    imagesString.add(widget.image3);
    imagesString.add(widget.image4);
    imagesString.add(widget.image5);
    setUpImages();
    super.initState();
  }
  
  String getDate(DateTime d){
    return d.day.toString()+" "+dateUtility.getMonthName(d)+" "+ d.year.toString();
  }

  void setUpImages(){
    for(int i=0;i<imagesString.length;i++){
      try{
        imgs.add(Image.memory(
          base64Decode(imagesString[i]),
          fit:BoxFit.fill,
        ));
      }catch(Exception){
        print("IMAGE["+i.toString() +"] ERROR!");
        print(Exception);
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return Scaffold(
      appBar: AppBar(
        title: const Text('Flutter WebView example'),
        // This drop down menu demonstrates that Flutter widgets can be shown over the web view.
        /*actions: <Widget>[
          NavigationControls(_controller.future),
          SampleMenu(_controller.future),
        ],*/
      ),
      // We're using a Builder here so we have a context that is below the Scaffold
      // to allow calling Scaffold.of(context) so we can show a snackbar.
      body: Builder(builder: (BuildContext context) {
        return WebView(
          initialUrl: 'https://flutter.dev',
          javascriptMode: JavascriptMode.unrestricted,
        );
      }),
    );


    /*
    return Scaffold(
      body: AnnotatedRegion<SystemUiOverlayStyle>(
          value: SystemUiOverlayStyle(
            statusBarColor: constants.LIGHT_GREEN,
          ),

          child: Align(
              alignment: Alignment.topCenter,
              child: SafeArea(
                  left: true,
                  top: true,
                  right: true,
                  bottom: true,
                  //minimum: const EdgeInsets.only(left:16.0, right: 16.0, bottom: 16.0),
                  child:Column(
                    children: [
                      Stack(
                          overflow: Overflow.visible,
                          children: <Widget>[

                            Positioned(
                              child: Container(
                                height: 60,
                                decoration: BoxDecoration(
                                  color: constants.LIGHT_GREEN,
                                  //color: Colors.blueGrey,
                                  borderRadius: BorderRadius.vertical(bottom: Radius.circular(20)),
                                  boxShadow: [
                                    BoxShadow(
                                      color: Colors.black.withOpacity(0.3),
                                      spreadRadius: 5,
                                      blurRadius: 7,
                                      offset: Offset(0, 3), // changes position of shadow
                                    ),
                                  ],

                                ),
                                child:Row(
                                  children: [
                                    IconButton(
                                      icon: Icon(Icons.arrow_back,color: Colors.white, size: 30,),
                                      onPressed: () {
                                        Navigator.pop(context);
                                      },
                                    ),
                                    Expanded(
                                      child:  Container(
                                        height: 40,

                                        decoration: BoxDecoration(
                                          color: constants.DARK_GREEN,
                                          //color: Colors.blueGrey,
                                          borderRadius: BorderRadius.circular(20),

                                        ),
                                      ),
                                    ),

                                    IconButton(
                                      icon: Icon(Icons.search,color: Colors.white,size: 30,),
                                      onPressed: () {},
                                    ),
                                  ],
                                ),
                              ),
                            ),
                          ]
                      ),

                      SizedBox(height: 20,),
                Expanded(child: WebView(
                  initialUrl: 'https://flutter.dev',
                ),
                )

                      /*
                      Align(
                        alignment: Alignment.centerRight,
                        child: Container(
                          child: Text(
                            getDate(DateTime.parse(dateTime)),
                            style: TextStyle(
                              fontSize: 16,
                            ),
                          ),
                        ),
                      ),
                      Align(
                        alignment: Alignment.center,
                        child: Container(
                          child: AutoSizeText(
                            title,
                            style: TextStyle(
                              fontSize: 20,
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                        ),
                      ),
                      Align(
                        alignment: Alignment.centerLeft,
                        child: Container(
                          child: AutoSizeText(
                            text,
                            style: TextStyle(
                              fontSize: 16
                            ),
                          ),
                        ),
                      ),
                      SizedBox(height: 20,),
                      imgs[0],
                  Expanded(
                      child:GridView.count(

                        primary: false,
                        padding: const EdgeInsets.all(20),
                        crossAxisSpacing: 10,
                        mainAxisSpacing: 10,
                        crossAxisCount: 2,
                        children: <Widget>[
                          Container(
                            padding: const EdgeInsets.all(8),
                            child: const Text("He'd have you all unravel at the"),
                            color: Colors.teal[100],
                          ),
                          Container(
                            padding: const EdgeInsets.all(8),
                            child: const Text('Heed not the rabble'),
                            color: Colors.teal[200],
                          ),
                          Container(
                            padding: const EdgeInsets.all(8),
                            child: const Text('Sound of screams but the'),
                            color: Colors.teal[300],
                          ),
                          Container(
                            padding: const EdgeInsets.all(8),
                            child: const Text('Who scream'),
                            color: Colors.teal[400],
                          ),
                          Container(
                            padding: const EdgeInsets.all(8),
                            child: const Text('Revolution is coming...'),
                            color: Colors.teal[500],
                          ),
                          Container(
                            padding: const EdgeInsets.all(8),
                            child: const Text('Revolution, they...'),
                            color: Colors.teal[600],
                          ),
                        ],
                      )
                  ),*/

              ],
            )
          )
        )
      ),
    );*/
  }
}