import 'dart:io';
import 'dart:typed_data';
import 'dart:developer';
import 'package:flutter/cupertino.dart';
import 'package:flutter/services.dart';
import 'package:lottie/lottie.dart';
import 'package:flutter/material.dart';
import 'package:tcp_socket_connection/tcp_socket_connection.dart';
import 'package:we_clean_project/newsOpen.dart';
import 'constants.dart' as constants;
import 'dart:convert';
import 'package:expandable/expandable.dart';
import 'package:auto_size_text/auto_size_text.dart';

class NewsPage extends StatefulWidget {
  NewsPage({Key key}) : super(key: key);

  @override
  _NewsPage createState() => _NewsPage();
}

class _NewsPage extends State<NewsPage> {
  TcpSocketConnection server=new TcpSocketConnection("192.168.1.110", constants.SERVER_PORT);

  int numberReceived=0;
  List<News> news=new List<News>();

  @override
  void initState() {
    askNews();
    super.initState();
  }

  void askNews()async {
    //String result=await getNetworkData();
    //log(result);
    //log("LENGTH"+result.length.toString()+" "+IMAGEPATH.length.toString());
    //await server.simpleConnect(10000, messageReceived);

    await server.connect(10000, "EOSWITHIMAGE", messageReceived);
    server.sendMessage("GETNEWS%_%"+numberReceived.toString()+"%_%EOS");
    //connect(10000, "EOSWITHIMAGE", messageReceived);

  }
/*
  connect(int timeOut, String eos,  Function callback) async{
    /*Future<String> getNetworkData() async {
    String result="ABC";
      Socket s = await Socket.connect("192.168.1.110", constants.SERVER_PORT);
      s.add(utf8.encode("GETNEWS%_%"+numberReceived.toString()+"%_%EOS"));

      final response = await s.close().then((response){ response.cast<List<int>>().transform(utf8.decoder).listen((content) { result=content; }); });
      log("RESPONDE DONE");
      return result;*/
      //String result = await s.transform(utf8.decoder).join();
      //await s.close(); // probably need to close the socket
     // return result;
    //}

    Socket socket = await Socket.connect("192.168.1.110", 4445);
    socket.add(utf8.encode("GETNEWS%_%"+numberReceived.toString()+"%_%EOS"));
    String message="";
    int length=0;
    int i=0;
    socket.listen(
            (onData) {
              String received=(String.fromCharCodes(onData));
              message+=received;
              if(received.contains("NEWS")){
                List<String> receivedSplit=received.split("%_%");
                if(receivedSplit.length>2){
                  length=int.parse(receivedSplit[1]);
                  log(length.toString());
                  i=i+3+receivedSplit[2].length;
                  log("LENGTH REACHED="+i.toString());
                }
              }else{
                i+=received.length;
              }
              log("LENGTH REACHED="+i.toString());
              if(i==length){
                log("FINALLY WE ARE AT IT!");
              }


            }
    );

    /*socket.listen((List<int> event) async {
      String received=(utf8.decode(event));
      log("RECEIVED= "+received);
      message += received;
      if(message.contains(eos)){
        callback(message.split(eos)[0]);
        if(message.split(eos).length>1){
          message=message.split(eos)[1];
        }else{
          message="";
        }
      }
    });*/
  }*/

  void messageReceived(String message){
    if(message.startsWith("NONE")){
      print("THERE ARE NO NEWS");
    }
    if(message.startsWith("NEWS")){
      //log("Complete Received is this fucking cock: "+message);
      message=message.replaceFirst("NEWS%_%", "");
      List<News> newsReceived;
      newsReceived=(json.decode(message) as List).map((i) => News.fromJson(i)).toList();
      //log("HELLO MADAFACA"+newsReceived[0].image1.compareTo(IMAGEPATH).toString());
      //log("LUNGHEZZE= "+newsReceived[0].image1.length.toString()+" "+IMAGEPATH.length.toString());
      //log(newsReceived[1].image1.compareTo(IMAGEPATH));
      /*for(int i=0;i<newsReceived.length;i++){
        /*newsReceived[i].img1=Image.memory(
            base64Decode(newsReceived[i].image1),
            fit:BoxFit.fill
        );*/

        try{
          newsReceived[i].img1=Image.memory(
            base64Decode(newsReceived[i].image1),
            fit:BoxFit.fill,
          );
        }catch(Exception){
          print("IMAGE ERROR!");
          print(newsReceived[i].image1.length);
          print(Exception);
        }
      }*/

      setState(() {
        news.addAll(newsReceived);
      });

    }
    server.disconnect();
  }


  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return Scaffold(
      body: AnnotatedRegion<SystemUiOverlayStyle>(
          value: SystemUiOverlayStyle(
            statusBarColor: constants.LIGHT_GREEN,
          ),

          child: Align(
              alignment: Alignment.topCenter,
              child: SafeArea(
                  left: true,
                  top: true,
                  right: true,
                  bottom: true,
                  //minimum: const EdgeInsets.only(left:16.0, right: 16.0, bottom: 16.0),
                  child:Column(
                    children: [
                      Stack(
                          overflow: Overflow.visible,
                          children: <Widget>[

                            Positioned(
                              child: Container(
                                height: 60,
                                decoration: BoxDecoration(
                                  color: constants.LIGHT_GREEN,
                                  //color: Colors.blueGrey,
                                  borderRadius: BorderRadius.vertical(bottom: Radius.circular(20)),
                                  boxShadow: [
                                    BoxShadow(
                                      color: Colors.black.withOpacity(0.3),
                                      spreadRadius: 5,
                                      blurRadius: 7,
                                      offset: Offset(0, 3), // changes position of shadow
                                    ),
                                  ],

                                ),
                                child:Row(
                                  children: [
                                    IconButton(
                                      icon: Icon(Icons.arrow_back,color: Colors.white, size: 30,),
                                      onPressed: () {
                                        Navigator.pop(context);
                                      },
                                    ),
                                    Expanded(
                                      child:  Container(
                                        height: 40,

                                        decoration: BoxDecoration(
                                          color: constants.DARK_GREEN,
                                          //color: Colors.blueGrey,
                                          borderRadius: BorderRadius.circular(20),

                                        ),
                                      ),
                                    ),

                                    IconButton(
                                      icon: Icon(Icons.search,color: Colors.white,size: 30,),
                                      onPressed: () {},
                                    ),
                                  ],
                                ),
                              ),
                            ),
                          ]
                      ),
                      SizedBox(height: 20,),
                      ListView.separated(

                        shrinkWrap: true,
                          padding: EdgeInsets.only(left: 20, right: 20),
                          physics: const BouncingScrollPhysics(),
                          scrollDirection: Axis.vertical,
                          itemCount: news.length,
                          itemBuilder: (BuildContext context, int index) {
                            return news[index].buildCard();
                          },
                        separatorBuilder: (BuildContext context, int index) => Padding(
                          padding: EdgeInsets.only(top:10, bottom: 10),
                          child:Center(
                            child:
                          Container(
                            width: 300,
                            height: 2,
                            decoration: BoxDecoration(
                              color: constants.DARK_GREEN,
                              borderRadius: BorderRadius.circular(1),
                            ),
                          ),
                        ),
                        ),
                      ),
                    ],
                  )
              )
          )
      )


    /*return Scaffold(
      backgroundColor: Colors.white,
      body: ExpandableTheme(
        data:
        const ExpandableThemeData(
          iconColor: Colors.blue,
          useInkWell: true,
        ),
        child:ListView.builder(
          padding: EdgeInsets.only(left: 20, right: 20),
            physics: const BouncingScrollPhysics(),
            scrollDirection: Axis.vertical,
            itemCount: news.length,
            itemBuilder: (BuildContext context, int index) {
              return news[index].buildCard();
            }
        ),
      ),*/



        /*child: ListView(
          physics: const BouncingScrollPhysics(),
          children: <Widget>[
            Card1(),
            Card2(),
            Card3(),
          ],
        ),
      ),*/
      /*
      body:   ExpandableNotifier(
        child:ListView.builder(
          scrollDirection: Axis.horizontal,
          itemCount: news.length,
          itemBuilder: (BuildContext context, int index) {

             /*return ExpandablePanel(
              header: Text(news[index].title),
              collapsed: Text(news[index].text, softWrap: true, maxLines: 2, overflow: TextOverflow.ellipsis,),
              expanded: Text(news[index].text, softWrap: true, ),
            );*/


            return Expandable(           // <-- Driven by ExpandableController from ExpandableNotifier
              collapsed: ExpandableButton(  // <-- Expands when tapped on the cover photo
                child:Container(
                width: 800,
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.circular(20),
                  color: constants.LIGHT_GREEN,
                ),
                child: Column(
                  children: [
                    Text(news[index].title),
                    Text(news[index].text),
                    Text(news[index].title),
                    Text(news[index].text),
                    Text(news[index].title),
                    Text(news[index].text),
                  ],
                ),
                ),
              ),
              expanded: Column(
                  children: [
                    Text(news[index].title),
                    Text(news[index].text),
                    Image.memory(base64Decode(news[index].image1)),
                    ExpandableButton(       // <-- Collapses when tapped on
                      child: Text("Back"),
                    ),
                  ]
              ),

            );
          },
        ),
      ),*/

    );
  }
}

class News{
  String id;
  String title;
  String text;
  String dateTime;
  String image1;
  String image2;
  String image3;
  String image4;
  String image5;
  Image img1;

  News();

  News.fromJson(Map<String, dynamic> json)
      : id = json['id'],
        title = json['title'],
        text = json['text'],
        dateTime = json['dateTime'],
        image1 = json['image1'],
        image2 = json['image2'],
        image3 = json['image3'],
        image4=json['image4'],
        image5=json['image5']
  ;

  Map<String, dynamic> toJson() =>
      {
        'id': id,
        'title': title,
        'text': text,
        'dateTime': dateTime,
        'image1': image1,
        'image2': image2,
        'image3': image3,
        'image4': image4,
        'image5':image5,
      };

  @override
  String toString() {
    return this.toJson().toString();
  }

  Widget buildCard(){
    return new Card1(
      title:this.title,
      text:text,
      dateTime:dateTime,
      image1:image1,
      image2:image2,
      image3:image3,
      image4:image4,
      image5:image5,
    );
  }
}



class Card1 extends StatefulWidget {
  Card1(
      {Key key, this.text, this.title, this.image1, this.image2, this.image3, this.image4, this.image5,this.dateTime})
      : super(key: key);
  final text;
  final title;
  final dateTime;
  final image1;
  final image2;
  final image3;
  final image4;
  final image5;

  @override
  _Card1 createState() => _Card1();
}


class _Card1 extends State<Card1> {
  String text;
  String title;
  String dateTime;
  String image1;
  String image2;
  String image3;
  String image4;
  String image5;
  Image img1;
  Image img2;
  Image img3;
  Image img4;
  Image img5;

  @override
  void initState() {
    text=widget.text;
    title=widget.title;
    dateTime=widget.dateTime;
    image1=widget.image1;
    image2=widget.image2;
    image3=widget.image3;
    image4=widget.image4;
    image5=widget.image5;
    setUpImage();
    super.initState();
  }

  void setUpImage(){
    try{
      img1=Image.memory(
        base64Decode(image1),
        fit:BoxFit.fill,
      );
    }catch(Exception){
      print("IMAGE[1] ERROR!");
      print(Exception);
    }

  }

  void openNews(){


    Navigator.push(
      context,
      PageRouteBuilder(
        pageBuilder: (c, a1, a2) =>  NewsOpen(
          dateTime: dateTime,
          title: title,
          text: text,
          image1: image1,
          image2: image2,
          image3: image3,
          image4: image4,
          image5: image5,
        ),
        transitionsBuilder: (c, anim, a2, child) => FadeTransition(opacity: anim, child: child),
        transitionDuration: Duration(milliseconds: 300),
      ),
    );
    /*
    Navigator.push(
        context,
        MaterialPageRoute(builder: (context) => NewsOpen(
          dateTime: dateTime,
          title: title,
          text: text,
          image1: image1,
          image2: image2,
          image3: image3,
          image4: image4,
          image5: image5,
        )));*/
  }



  @override
  Widget build(BuildContext context) {

    return GestureDetector(
        onTap: ()=>openNews(),
        behavior:  HitTestBehavior.translucent,
        child:Container(
            child:Row(
                children: [
                  Container(
                      height: 100,
                      width: 100,
                      decoration: BoxDecoration(
                        color: constants.WHITE,
                        borderRadius: BorderRadius.circular(20.0),
                        boxShadow: kElevationToShadow[4],
                      ),
                      child:ClipRRect(
                        borderRadius: BorderRadius.circular(20.0),
                        child:img1,
                      )
                  ),
                  Expanded(
                    child:Container(
                      height: 100,
                        child: Padding(
                          padding:EdgeInsets.only(left:20,right: 20),
                            child: Center(
                          child:AutoSizeText(
                            title,
                            minFontSize: 20,
                            maxLines: 4,
                            textAlign: TextAlign.center,
                          )
                        )
                        )
                    )
                  )
                ]
            )
        )
    );
    /*
    return Card(
      child: Column(
        mainAxisSize: MainAxisSize.min,
        children: <Widget>[
          const ListTile(
            leading: Image.memory(base64Decode(image1), width: 100, height: 100,),
            title: Text('Heart Shaker'),
            subtitle: Text('TWICE'),
          ),
        ],
      ),
    );*/
    /*return ExpandableNotifier(
        child: Padding(
          padding: const EdgeInsets.all(10),
          child: Card(

            clipBehavior: Clip.antiAlias,
            child: Column(
              children: <Widget>[
                /*
                SizedBox(

                  child: Container(
                    height: 150,
                    width: 100,
                    decoration: BoxDecoration(
                      color: Colors.orange,
                      shape: BoxShape.rectangle,
                    ),
                  ),
                ),*/
                ScrollOnExpand(
                  scrollOnExpand: true,
                  scrollOnCollapse: false,
                  child: ExpandablePanel(
                    theme: const ExpandableThemeData(
                      headerAlignment: ExpandablePanelHeaderAlignment.center,
                      tapBodyToCollapse: true,
                    ),
                    header: Padding(
                        padding: EdgeInsets.all(10),
                        child: Row(
                          //mainAxisAlignment: MainAxisAlignment.start, //Center Column contents vertically,
                          //crossAxisAlignment: CrossAxisAlignment.center, //Center Column contents horizontally,
                          children: [
                            SizedBox(

                              child: Container(
                                height: 150,
                                width: 150,
                                decoration: BoxDecoration(
                                  color: Colors.orange,
                                  shape: BoxShape.rectangle,
                                ),
                              ),
                            ),
                            Spacer(),
                            Center(
                              child:Text(
                                title,
                                style: TextStyle(
                                  fontSize: 20,
                                ),
                              )
                            ),
                            Spacer(),

                          ],
                        )


                        ),
                    collapsed: Text(
                      text,
                      softWrap: true,
                      maxLines: 2,
                      overflow: TextOverflow.ellipsis,
                    ),
                    expanded: Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: <Widget>[
                          Padding(
                              padding: EdgeInsets.only(bottom: 10),
                              child: Text(
                                text,
                                softWrap: true,
                                overflow: TextOverflow.fade,
                              )),
                        Padding(
                            padding: EdgeInsets.only(bottom: 10),
                            child: Image.memory(base64Decode(image1), width: 100, height: 100,),
                        )
                      ],
                    ),
                    builder: (_, collapsed, expanded) {
                      return Padding(
                        padding: EdgeInsets.only(left: 10, right: 10, bottom: 10),
                        child: Expandable(
                          collapsed: collapsed,
                          expanded: expanded,
                          theme: const ExpandableThemeData(crossFadePoint: 0),
                        ),
                      );
                    },
                  ),
                ),
              ],
            ),
          ),
        ));*/
  }
}



/*
class Card1 extends StatelessWidget {
  Card1({Key key, this.text, this.title, this.image1, this.image2, this.image3, this.image4,this.image5}) : super(key: key);
  final text;
  final title;
  final image1;
  final image2;
  final image3;
  final image4;
  final image5;

  Future<Widget> buildImage()async{
    Image img=await new Image.memory(
      base64Decode(image1),
      fit: BoxFit.fill,
    );
    return img;
  }

  @override
  Widget build(BuildContext context) {

    return GestureDetector(
      onTap: (){print("TAPPED");},
        behavior:  HitTestBehavior.translucent,
        child:Container(
            child:Row(
                children: [
                  Container(
                      height: 100,
                      width: 100,
                      decoration: BoxDecoration(
                        color: constants.WHITE,
                        borderRadius: BorderRadius.circular(20.0),
                        boxShadow: kElevationToShadow[4],
                      ),
                      child:ClipRRect(
                        borderRadius: BorderRadius.circular(20.0),

                        child: buildImage(),
                      )
                  ),
                  Spacer(),
                  Center(
                      child:Text(
                        title,
                        style: TextStyle(
                          fontSize: 20,
                        ),
                      )
                  ),
                  Spacer(),
                ]
            )
        )
    );
    /*
    return Card(
      child: Column(
        mainAxisSize: MainAxisSize.min,
        children: <Widget>[
          const ListTile(
            leading: Image.memory(base64Decode(image1), width: 100, height: 100,),
            title: Text('Heart Shaker'),
            subtitle: Text('TWICE'),
          ),
        ],
      ),
    );*/
    /*return ExpandableNotifier(
        child: Padding(
          padding: const EdgeInsets.all(10),
          child: Card(

            clipBehavior: Clip.antiAlias,
            child: Column(
              children: <Widget>[
                /*
                SizedBox(

                  child: Container(
                    height: 150,
                    width: 100,
                    decoration: BoxDecoration(
                      color: Colors.orange,
                      shape: BoxShape.rectangle,
                    ),
                  ),
                ),*/
                ScrollOnExpand(
                  scrollOnExpand: true,
                  scrollOnCollapse: false,
                  child: ExpandablePanel(
                    theme: const ExpandableThemeData(
                      headerAlignment: ExpandablePanelHeaderAlignment.center,
                      tapBodyToCollapse: true,
                    ),
                    header: Padding(
                        padding: EdgeInsets.all(10),
                        child: Row(
                          //mainAxisAlignment: MainAxisAlignment.start, //Center Column contents vertically,
                          //crossAxisAlignment: CrossAxisAlignment.center, //Center Column contents horizontally,
                          children: [
                            SizedBox(

                              child: Container(
                                height: 150,
                                width: 150,
                                decoration: BoxDecoration(
                                  color: Colors.orange,
                                  shape: BoxShape.rectangle,
                                ),
                              ),
                            ),
                            Spacer(),
                            Center(
                              child:Text(
                                title,
                                style: TextStyle(
                                  fontSize: 20,
                                ),
                              )
                            ),
                            Spacer(),

                          ],
                        )


                        ),
                    collapsed: Text(
                      text,
                      softWrap: true,
                      maxLines: 2,
                      overflow: TextOverflow.ellipsis,
                    ),
                    expanded: Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: <Widget>[
                          Padding(
                              padding: EdgeInsets.only(bottom: 10),
                              child: Text(
                                text,
                                softWrap: true,
                                overflow: TextOverflow.fade,
                              )),
                        Padding(
                            padding: EdgeInsets.only(bottom: 10),
                            child: Image.memory(base64Decode(image1), width: 100, height: 100,),
                        )
                      ],
                    ),
                    builder: (_, collapsed, expanded) {
                      return Padding(
                        padding: EdgeInsets.only(left: 10, right: 10, bottom: 10),
                        child: Expandable(
                          collapsed: collapsed,
                          expanded: expanded,
                          theme: const ExpandableThemeData(crossFadePoint: 0),
                        ),
                      );
                    },
                  ),
                ),
              ],
            ),
          ),
        ));*/
  }
}*/